### Read MMLA corpus files (audio, timing and scores)

### This program is free software; you can redistribute it and/or
### modify it under the terms of the GNU General Public License
### as published by the Free Software Foundation; either version 2
### of the License, or (at your option) any later version.
###
### © 2013 S. Luz (luzs@acm.org)

##  options(width=100) for wider terminals  
options(width=130)
source('markov.R')

## comment this out if you are not using RWeka functions
## (e.g. read.arff(), make_Weka_classifier() etc)
require('RWeka')

DATADESC <- list(G1D1=list(speakers=c(1:3), gender=c('m','m','m'), performance='high',
                   expert='S1', leader='S1'),
                 G1D2=list(speakers=c(1:3), gender=c('m','m','m'), performance='high',
                   expert='S1', leader='S2'),
                 G2D1=list(speakers=c(4:6), gender=c('f','f','f'), performance='low',
                   expert='S5', leader='S5'),
                 G2D2=list(speakers=c(4:6), gender=c('f','f','f'), performance='low',
                   expert='S5', leader='S4'),
                 G3D1=list(speakers=c(7:9), gender=c('f','f','f'), performance='high',
                   expert='S7', leader='S7'),
                 G3D2=list(speakers=c(7:9), gender=c('f','f','f'), performance='high',
                   expert='S7', leader='S8'),
                 G4D1=list(speakers=c(10:12), gender=c('m','m','m'), performance='moderate',
                   expert='S12', leader='S11'),
                 G4D2=list(speakers=c(10:12), gender=c('m','m','m'), performance='high',
                   expert='S12', leader='S10'),
                 G5D1=list(speakers=c(13:15), gender=c('m','m','m'), performance='high',
                   expert='S14', leader='S13'),
                 G5D2=list(speakers=c(13:15), gender=c('m','m','m'), performance='high',
                   expert='S14', leader='S14'),
                 G6D1=list(speakers=c(16:18), gender=c('f','f','f'), performance='high',
                   expert='S17', leader='S17'),
                 G6D2=list(speakers=c(16:18), gender=c('f','f','f'), performance='high',
                   expert='S17', leader='S16'))

## Load vocalisation datasets (including very short vocalisations (<1s long)
makeRawVocDataSet <- function(datadir='../data/', sessions=names(DATADESC)) {
  df <- data.frame(vstart=NULL,vend=NULL,speaker=NULL,session=NULL)
  for (s in sessions) {
    d <- read.csv(file=paste(datadir,s,'.txt',sep=''), sep='\t',  header=F, col.names=c('vstart','vend','label'))
    di <-  which(d$label==1)
    spks <- c(rep(DATADESC[[s]]$speakers[1],di[2]-di[1]),
              rep(DATADESC[[s]]$speakers[2],di[3]-di[2]),
              rep(DATADESC[[s]]$speakers[3],length(d$label)+1-di[3]))
    df <- rbind(df,cbind(d[,1:2],speakers=spks,session=s))
  }
  return(df)
}

## load metadata (coding)
makeProblemTimeScoresDataSet <- function(datadir='../data/', sessions=names(DATADESC)) {
  df <- data.frame(session=NULL,pid=NULL,pstart=NULL,pend=NULL,
                   moistart=NULL,moiend=NULL,tts=NULL,correct=NULL,spkanswer=NULL,spkexplain=NULL)
  for (s in sessions) {
    d <- read.csv(file=paste(datadir,s,'_time_boundaries.csv',sep=''),
                  sep=',', strip.white=T, header=F)
    d <- d[-1,] ## ignore header
    dfaux <- data.frame(session=s,pid=gsub(':','',as.character(d$V1)),
                        ## all times converted to secs
                        pstart=as.numeric(as.difftime(as.hhmmssTime(d$V2),
                          format="%H:%M:%S", units='s')),
                        pend=as.numeric(as.difftime(as.hhmmssTime(d$V3),
                          format="%H:%M:%S", units='s')),
                        moistart=as.numeric(as.difftime(as.hhmmssTime(d$V4),
                          format="%H:%M:%S", units='s')),
                        moiend=as.numeric(as.difftime(as.hhmmssTime(d$V5),
                          format="%H:%M:%S", units='s')),
                        tts=as.numeric(gsub('[^0-9]','',as.character(d$V6))),
                        correct=d$V7=='Y', spkanswer=d$V8, spkexplain=d$V9
                        )
    df <- rbind(df,dfaux)
  }
  df
}

##  get vocalisation table as on-off patterns per speaker at a sample
##  rate specified by 'rate'.
##
##  session in {G1D1, ...}
##  pid = problem id (1A, 1B, ...)
##  rate = sampling rate; default 100ms
getProblemVocTable <- function(session, pid, rate=.1, minvocsize=1,
                               vocdf=NULL, probdf=NULL){
  if (is.null(vocdf)){ ## it's better to do this once and pass vocdf and probdf as args
    vocdf <- makeRawVocDataSet()
    ## remove vocs shorter than minvocsize
    vocdf <- filterOutSmallVocs(vocdf,minvocsize=minvocsize)
  }
  if (is.null(probdf)){
    probdf <- makeProblemTimeScoresDataSet()
  }
  p <- which(probdf$pid==pid&probdf$session==session)
  pstart <- probdf$pstart[p]
  pend <- probdf$pend[p]
  vocdf <- vocdf[vocdf$session==session&vocdf$vstart>=pstart&vocdf$vstart<=pend,]
  times <- seq(pstart, pend , by=rate)
  ## creat an empty df
  df <- data.frame(time=times,
                   sa=rep(FALSE,length(times)), ## first speaker (default=silence)
                   sb=rep(FALSE,length(times)),
                   sc=rep(FALSE,length(times)))
  speakers <-  unique(vocdf$speaker)
  names(df) <- c('time', paste('S',speakers, sep=''))
  ## build voice activity profiles
  for (s in speakers ) {
    sn <- paste('S',s, sep='')
    timeon <- unlist(sapply(which(vocdf$speaker==s), function(X){which(times>=vocdf$vstart[X]&times<=vocdf$vend[X])}))
    df[[sn]][timeon] <- TRUE  ## voice activity for sn
  }
  ## build vocalisation sequence (compatible with Vocalisation types in vocalgraphs.R
  spseq <- vector(length=length(df[,2])) ## df[,2] == first speaker (sa)
  spseq[which(!df[,2] & !df[,3] & !df[,4])] <- 'Floor'
  spseq[which(df[,2])] <- names(df)[2]
  spseq[which(df[,3])] <- names(df)[3]
  spseq[which(df[,4])] <- names(df)[4]
  spseq[which( df[,2] & df[,3] & df[,4] | df[,2]&df[,3] | df[,4] & df[,3] | df[,2] & df[,3] )] <- 'Grp'
  cbind(df,speaker=spseq)
}

filterOutSmallVocs <- function (vocdf, minvocsize=1){
  vocdf[vocdf$vend-vocdf$vstart>minvocsize,]
}

## Return the sub-df of vocdf containing all vocalisations in problem
## pid of session, according to probdf
getSessionProblemVocs <- function(vocdf, probdf, session, pid){
  p <- which(probdf$pid==pid&probdf$session==session)
  pstart <- probdf$pstart[p]
  pend <- probdf$pend[p]
  vocdf[vocdf$session==session&vocdf$vstart>=pstart&vocdf$vstart<=pend,]
}

## getSampledVocalMatrix:
## ======================
## Retrieve (probability) "vocalisation matrix" (i.e. a matrix
## representation of a dialogue as a Markov process whose cell <m,n>
## contains the transition probability from node m to node n)
##
## RETURNS: list containing: (1) a TTARRAY: the vocalisation matrix
## proper, in which all rows sum to 1, and (2) TDARRAY: an absolute
## (i.e. based on real-valued time intervals rather than sample
## counts) turn duration vector which corresponds to the static
## distribution for TTARRAY (i.e. TTARRAY^n[], the matrix
## representation of the Chapman-Kolmogorov equation, as n approaches
## INF)
##
## SEE ALSO: getSampledVocalCountMatrix()
##
getSampledVocalMatrix <- function (speakers) {
  vcm <- getSampledVocalCountMatrix(speakers)
  tdarray <- vcm$tdarray/sum(vcm$tdarray)   ## normalise turn-distribution vector
  rsum <-  apply(vcm$ttarray, 1, sum)                   ## sum rows
  ttarray <- apply(vcm$ttarray, 2, function(z){z/rsum}) ## normalise each column
  
  return(list(ttarray=ttarray, tdarray=tdarray))
}

## Retrieve "vocalisation count matrix" (i.e. a matrix whose cell
## <m,n> contains the number of times a transition from node m to node
## n was recorded). The input is a vecotr of vocalisations (or
## silences) obtained by sampling the timeline every 'rate'-th
## second. The returned list contains: the vocalisation matrix proper
## (ttarray) and a turn distribution vector (tdarray). The relation
## between these two arrays is the following: sum(ttarray[n,] is
## approximately tdarray[n] at the default sampling rate of 1.
getSampledVocalCountMatrix <- function (speakers) {
  if (is.factor(speakers)) 
    nodes <- levels(speakers)
  else ## speakers is not a factor; treat as stringarray
    nodes <- unique(speakers)
  ## absolute duration (static distribution); ttarray^n (i.e. the
  ## matrix representation of the Chapman-Kolmogorov equation) should
  ## converge to tdarray as n approaches infinity
  tdarray <- array(data=0,
                   dim=c(length(nodes)),
                   dimnames=list(nodes))
  tdarray <-  sapply(nodes, function(y){ sum(speakers==y)})
  ttarray <- array(data=0,
                   dim=c(length(nodes),length(nodes)),
                   dimnames=list(nodes, nodes))
  pspk <- speakers[1]
  for (sp in speakers[-1] ) {
    ttarray[pspk, sp] <- ttarray[pspk, sp] + 1
    pspk <- sp
  }
  if (sum(ttarray[pspk,])==0) ## prevent zero-transition rows (and div by zero in getSampledVocalMatrix)
    ttarray[pspk,pspk] <- 1
  return(list(ttarray=ttarray, tdarray=tdarray))
}

## getTurnType: return one of {Vocalisation, GrpVocalisation, ...}  or
## the speaker identifier, if individual set to TRUE
getTurnType <- function(speakers, i, individual=F, noPauseTypes=F) {
  paste(i,", ")
  currentspeaker <- as.character(speakers[i])
  nextspeaker <- 'none'
  if (length(speakers) > i ){
    nextspeaker <- as.character(speakers[i+1])
  }
  prevspeaker <- if (i > 1 ) as.character(speakers[i-1]) else 'none'
  if (currentspeaker == 'Floor') {
    if (individual && noPauseTypes) return(currentspeaker) else return(getPauseType(prevspeaker, nextspeaker))
  }
  else if (currentspeaker == 'Grp'){
    if (individual) return(currentspeaker) else return('GrpVocalisation') 
  }
  else {
    if (individual) return(currentspeaker) else return('Vocalisation')
  }
}

## Return the type of pause a 'Floor' (silence) event represents:
## 'Pause', 'SwitchingPause', 'GrpPause', or 'GrpSwitchingPause'. See
## [Luz & Kane 2009] for details.
getPauseType <- function(prevspeaker, nextspeaker){
  if (prevspeaker == 'Floor' ){
    warning("OOPS! Two consecutive Floor turns found. A coding error??")
    return('Pause')
  }
  if ( prevspeaker == 'none' || nextspeaker == 'none') return('Pause')
  if ( prevspeaker == 'Grp'){
    if (nextspeaker == 'Grp') return('GrpPause') else return('GrpSwitchingPause')
  }
  if (prevspeaker != nextspeaker) return('SwitchingPause') else return ('Pause')
}


## printPerformanceARFFfile()
## --------------
## use this to generate turn-taking diragrams in ARFF format for
## processing with the WEKA machine learning toolkit.
## Example:
##
## generateARFF(file="/tmp/t.arff", individual=T, twoclass=T)
##
printPerformanceARFFfile <- function(vocdf=filterOutSmallVocs(makeRawVocDataSet()), 
                                     probdf=makeProblemTimeScoresDataSet(),
                                     ##sessions=names(DATADESC), ## sessions to print
                                     individual=F, ## keep speaker ids? (if F print general vocgraph
                                     anonymous=F, ## anonymomise speaker IDs (if individual=T)
                                     target='correct', ## one of probdf column names
                                     file="/tmp/test.arff") ## name of ARFF file to be generated
{
  call <- format(sys.call())
  head <- paste(c("% file automatically generated by expertdet.R\n",
                  "% ", call,
                  "\n\n@RELATION mmla\n\n"), collapse="")

  d <- getVocalMatrixDataSet(probdf, vocdf, individual=individual,
                             anonymous=anonymous)
  nodes <- d$nodes
  tvector <- d$tvector
  ## attributes consits of all node names (the values of which
  ## represent the probability of that node) and all combinations of
  ## nodes (values representing transition probabilities)
  attributes <- c(paste(nodes),
                  sapply(nodes, function(x){paste(nodes,'-',x,sep='')}))
  targetclass <- unique(probdf[[target]])
  mla <- max(nchar(attributes))
  body <- c(sapply(attributes,
                   function(x){pad <- mla - nchar(x);
                               paste(c("@ATTRIBUTE ",x,rep(" ",pad)," REAL\n"),
                                     collapse="")}),
            paste(c("@ATTRIBUTE ",target," {",
                    paste(targetclass,collapse=","),"}\n"),collapse=""),
            "\n\n@DATA\n")
  ##
  for (tv in tvector) {
    t <- tv$ttpm
    i <- tv$pid     ## pid and session  should not be part of the instance 
    s <- tv$session ## representation (use them as comments)
    ## tda: sparse array containing all spkr turn durations,
    ## whereas t$tdarray contain only those that occur in case i
    tda <- array(data=0, dim=c(length(nodes)), dimnames=list(nodes))
    tda[names(t$tdarray)] <- t$tdarray
    tta <- array(data=0, dim=c(length(nodes),length(nodes)),
                 dimnames=list(nodes,nodes))
    line <- paste(tda, collapse=",")
    n <- dimnames(t$ttarray)[[1]]
    for  (j in n){
      for  (k in n){
        if (t$ttarray[j,k] == 0) next
        tta[j,k] <- t$ttarray[j,k]
      }
    }
    correct <- probdf$correct[probdf$session==s&probdf$pid==i]
    ##correct <- sapply(correct, function(c) if (c) 'yes' else 'no')
    line <- paste(c(line,
                    paste(tta, collapse=","),
                    correct),
                  collapse=",")
    body <- c(body, line,"\n")
  }
  o <- paste(c(head,body),collapse="")
  cat(o, file=file)
}

getVocalMatrixDataSet <- function (probdf, vocdf, individual=F, anonymous=F,pausetypes=T){
  nodes <- c()
  tvector <- c(list())
  for  (i in 1:length(probdf$session)) {
    #for (p in levels(probdf$pid)) {
    s <- probdf$session[i]
    p <- probdf$pid[i]
    spks <- getProblemVocTable(s,p, vocdf=vocdf, probdf=probdf)$speaker
    if (pausetypes)
      spks <- identifyPauses(spks)
    else
      spks <- as.character(spks)
    if ( individual ) {
      t <- getSampledVocalMatrix(identifyGrpVocalisations(spks))
    }
    else
      t <- getSampledVocalMatrix(identifyVocalisations(spks))
      if (anonymous && individual) {
        t <- getAnonymousProbMatrix(t)
      }
      nodes <- union(nodes, names(t$tdarray))
      tvector <- c(tvector, list(list(ttpm=t, session=s, pid=p)))
    #}
  }
  list(nodes=nodes, tvector=tvector)
  
}

getExpertLeaderDataSet <- function(vocdf=filterOutSmallVocs(makeRawVocDataSet()), 
                                         probdf=makeProblemTimeScoresDataSet()
                                         )
{

  
  d <- getVocalMatrixDataSet(probdf, vocdf, individual=T,anonymous=F,pausetypes=F)
  tvector <- d$tvector
  df <- data.frame(session=NULL, ## session ID, for ref purposes only (not part of item representation)
                   pid=NULL,     ## problem ID, for ref purposes only (not part of item representation)
                   speaker=NULL, ## speaker ID, for ref purposes only (not part of item representation)
                   vocsum=NULL,  ## sum of voc durations
                   vocmean=NULL, ## mean duration
                   vocsd=NULL,   ## voc standard dev
                   pSgF=NULL,    ## p(speaker|floor)
                   pFgS=NULL,    ## p(floor|speaker) ; prob of a transition from s to floor
                   pSgG=NULL,    ## p(speaker|groupvoc)
                   pGgS=NULL,    ## p(groupvoc|speaker)
                   entS=NULL,    ## entropy of p(s_i|speaker)
                   expert=NULL, ## dominant expert (Boolean)
                   leader=NULL ## session leader?
                   )
  for (tv in tvector) {
    ## iterate through vocalisation graphs
    t <- tv$ttpm
    i <- tv$pid     ## pid and session  should not be part of the instance 
    s <- tv$session ## representation for ML purposes
    expert <- DATADESC[[s]]$expert
    leader <- DATADESC[[s]]$leader
    #speakers <- names(t$tdarray)[!names(t$tdarray)%in%categories]
    ## get original vocalisation intervals for graph under examination
    vocs <- getSessionProblemVocs(vocdf, probdf, s, i)
    ## make speaker IDs compatible with those in ttpm
    vocs$speakers <- paste('S',vocs$speakers,sep='')
    for (spk in unique(vocs$speakers)){
      ## vocalisations for target speakr
      svoc <- vocs[vocs$speakers==spk,]
      ## durations 
      vocdur <- svoc$vend-svoc$vstart
      adf <- data.frame(session=s,
                        pid=i,
                        speaker=spk,
                        vocsum=sum(vocdur),
                        vocmean=mean(vocdur),                           ## mean duration
                        vocsd=if (length(vocdur)<2) 0 else sd(vocdur),  ## voc standard dev
                        pSgF=getPofAgivenB(spk,'Floor',t$ttarray),            ## p(speaker|floor)
                        pFgS=getPofAgivenB('Floor',spk,t$ttarray),            ## p(floor|speaker)
                        pSgG=getPofAgivenB(spk,'GrpVocalisation',t$ttarray),  ## p(speaker|groupvoc)
                        pGgS=getPofAgivenB('GrpVocalisation',spk,t$ttarray),  ## p(groupvoc|speaker)
                        entS=getEntropy(t$ttarray[spk,]),                     ## entropy of p(s_i|speaker)
                        expert=expert==spk    , ## dominant expert? (Boolean)
                        leader=leader==spk ## session leader?
                        )
      df <- rbind(df,adf)
    }
  }      
  df
}

######### Correct solution classification
runExperiment <- function(af,            ## name of the ARFF file to read (or a data frame)
                          nfold=1,       ## number of folds for cross-validation
                          splitdef=NULL, ## a vector of the form c(btr,etr,bts,ets) of
                                         ## indices for start and end of training an test set
                          split=.25,     ## the proportion of instances for test set 
                                         ## (ignored if nfold>1 is specified)
                          classifier=makeKnnClassifier(), ## classifier to use
                          controlpars=alist(), ##alist(K=F),## extra parameters for classifier (see WOW())
                          threshold=0,  ## threshold > 0 implies instance is positive if prob > threshold (RCut)
                          beta=1, ## beta parameter for F score
                          debuglevel=0,
                          target='correct',
                          refdataset=NULL, ## data set we take the training data from. If NULL, refdataset=af
                          title='Correctness prediction Experiment' ## A string desribing the experiment 
                          )      

{
  if (is.data.frame(af)){
    d <- af
    af <- cat(paste('data frame passed as argument (Target: ', target,
                    '; Generality: ', round(mean(d[[target]])*100, digits=1),
                    '%)\n', sep=''))
  }
  else
    d <- read.arff(af)
  ## make sure last column contains class data
  ## (i.e. factors). sead.arff seems to read 'TRUE' as boolean, which
  ## gets interpreted as 1 when passed to predict(), resulting in a
  ## regression rather than classification)
  d[[length(d)]] <- factor(d[[length(d)]])
  
  #clsr <- make_Weka_classifier(classifier)

  ## split dataset
  ld <- length(d[[1]])
  if (nfold > 1) ## no x-validation, ignore user split parameter
    split <- 1/nfold
  foldsize <- floor(ld*split)
  remainder <- ld%%nfold
  if (!is.null(splitdef))
    nfold <- length(splitdef)
  ## set classifier control parameters
  if (length(controlpars)>0)
    control <- do.call('Weka_control', controlpars)
  else
    control <- NULL
  ## set up object to store results
  tp <- tp_n <- tpUfn <- tpUfp <- tpUfn_n <- tpUfp_n <- 0
  rs <- rep(0,nfold)
  th <- rep(threshold,nfold)
  results <- list(call=format(sys.call()),
                  title=title,
                  clname=quote(classifier),
                  classifier=classifier, ## these could be used to build model as in 
                  control=control, ## m <- eval(results$classifier(boundary ~ ., data=arff,
                                   ##                              control=results$control)) 
                                   ## predict(m,arff-test)
                  threshold=th,
                  hyp=c(),
                  prob=c(),
                  ref=c()
                  )
  condCat('\nExperiment ', title,
          '\nEvaluating',af, 'on classifier', quote(classifier),
          '\n', print=debuglevel>=0)
  condCat('=========================================================================\n',
          print=debuglevel>=0)
  for (i in 1:nfold) {
    if (nfold==1) {      ## no x-validation, use split parameter
      sp <- ld-foldsize
      dtrain <- if (is.null(refdataset)) d[1:(sp),] else refdataset[1:(sp),]
      dtest <- d[(sp+1):ld,]
      fdesc <- sprintf("Test set indices: %i-%i", sp+1, ld)
    }
    else if (!is.null(splitdef)) {## user-specified split
      trb <- splitdef[[i]][1]
      tre <- splitdef[[i]][2]
      tsb <- splitdef[[i]][3]
      tse <- splitdef[[i]][4]
      fdesc <- sprintf("Test set indices: %i-%i", tsb, tse)
      dtrain <- if (is.null(refdataset)) d[trb:tre,] else refdataset[trb:tre,]
      dtest <- d[tsb:tse,]
    }
    else{                    ## do x-validation preserving instance order
      ## TODO: deal with remainder
      if (remainder>0){ r <- 1; remainder <- remainder-1; } else {r <- 0}
      sp <- (i-1)*foldsize + 1
      ep <- i*foldsize
      dtest <- d[sp:ep,]
      fdesc <- sprintf("Test set indices (fold %i): %i-%i", i, sp, ep)
      
      if (i == 1){           ## train on last n-1 folds
        dtrain <- if (is.null(refdataset)) d[(ep+1):ld,] else refdataset[(ep+1):ld,] 
      }
      else if (i == nfold){  ## train on first n-1 folds
        dtrain <- if (is.null(refdataset)) d[1:(sp-1),] else refdataset[1:(sp-1),]
      }
      else {                 ## make training set out of two discontinuous foldsets
        dtrain <- if (is.null(refdataset)) rbind(d[1:(sp-1),],d[(ep+1):ld,]) else rbind(refdataset[1:(sp-1),],refdataset[(ep+1):ld,])
      }
    }
  
    hyp <- classify(classifier, dtrain, dtest, controlpars=controlpars)
    ref <- dtest[[length(dtest)]]
    prob <- classify(classifier, dtrain, dtest,  controlpars=controlpars, type='probability')[,2]  ## to be implemented properly one day

    condCat('\nEvaluating',af, 'on classifier', quote(classifier),
            '- threshold:',results$threshold[i],'\n',
            print=debuglevel>=0)
    condCat('=======================================\n',
            print=debuglevel>=0)
    condCat('Split: ', split*100, '%  -- ', fdesc , '\n', sep='', print=debuglevel>=0)
    if (debuglevel>0){
      cat('Ref: ', as.character(ref), '\n',sep='')
      cat('Hyp: ', as.character(hyp), '\n',sep='')
    }
    condCat('\n', print=debuglevel>=0)
    tmpt <-
      paste("TRUE                     FALSE",
            "-------------------      ----------------------",
            "Accuracy:   %.3f         Accuracy:  %.3f",
            "Precision:  %.3f         Precision: %.3f      ",
            "Recall:     %.3f         Recall:    %.3f      ",
            "F_%i:        %.3f         F_%i:       %.3f",
            "Overall accuracy: %.3f\n",
            sep='\n')
    ## overall accuracy 
    A <- mean(ref==hyp)
    ## TRUE class
    At <- accuracy(hyp,ref,class=TRUE)
    Pt <- precision(hyp,ref,TRUE)
    Rt <- recall(hyp,ref,TRUE)
    Ft <- Fbeta(hyp,ref,TRUE,beta=beta)
    ## FALSE class
    Af <- accuracy(hyp,ref,class=FALSE)
    Pf <- precision(hyp,ref,FALSE)
    Rf <- recall(hyp,ref,FALSE)
    Ff <- Fbeta(hyp,ref,FALSE,beta=beta)

    condCat(sprintf(tmpt,
                    At, Af,
                    Pt, Pf,
                    Rt, Rf,
                    beta, Ft, beta, Ff,
                    A), print=debuglevel>=0)
    
    results$hyp[i] <- list(hyp)
    results$prob[i] <- list(prob)
    results$ref[i] <- list(ref)
  }
  results
}


## The datase should be split so that training is on complete problems
## (pid) and testing is on problem by problem so that the expert is
## by maximum likelihood ( S_e = argmax s P(data|s)P(s) )
##
runExpertExperiment <- function(af,      ## df produced by getExpertLeaderDataSet()
                          ntest=1,       ## number of problems for test set (default LOO)
                          classifier=makeNBClassifier(), ## classifier to use
                          controlpars=alist(), ##alist(K=F), pars for classifier (see WOW())
                          beta=1, ## beta parameter for F score
                          debuglevel=0,
                          features=4:11,   ## indices of features (cols) to be passed to classifier       
                          target='expert', ## name of column of df containing class (TRUE or FALSE)
                          title='Expert Experiment' ## A string desribing the experiment 
                          )      

{
  if (is.data.frame(af)){
    d <- af
    af <- paste('data frame passed as argument (Target: ', target,
                    '; Generality: ', round(mean(d[[target]])*100, digits=1),
                    '%)', sep='')
  }
  else
    d <- read.arff(af)

  ## make sure target contains class data
  ## (i.e. factors). sead.arff seems to read 'TRUE' as boolean, which
  ## gets interpreted as 1 when passed to predict(), resulting in a
  ## regression rather than classification)
  d[[target]] <- factor(d[[target]])

  ## create PID by session matrix
  sestable <- table(d$pid,d$session, ## need exclude to get rid of unsed levels if sub-df used
                    exclude=setdiff(levels(d$session),unique(d$session)))
  ## number of folds 
  ld <- ld <- length(d[[1]]) ## length of full df (= sum(sestable))
  lt <- length(sestable)     ## number of distinct problem sessions
  nfold <- lt/ntest ## each fold contains ntest PIDs  
  ## set up object to store results
  rs <- rep(0,nfold)
  results <- list(call=format(sys.call()),
                  title=title,
                  clname=quote(classifier),
                  classifier=classifier, ## these could be used to build model as in 
                  control=controlpars, ## m <- eval(results$classifier(boundary ~ ., data=arff,
                                   ##                              control=results$control)) 
                                   ## predict(m,arff-test)
                  threshold=0,     ## MAP classification (always)
                  hyp=c(),
                  prob=c(),
                  ref=c()
                  )
  condCat('\nExperiment', title,
          '\n', print=debuglevel>=0)
  condCat('===============================================\n',
          print=debuglevel>=0)
  sdf <- 1  ## aux variables storing positions of start and end of test portion of df 
  edf <- 0
  for (i in 1:nfold) {
    sp <- (i-1)*ntest + 1  ## fold indices for session x PID table
    ep <- i*ntest
    pidmap <- sestable[sp:ep] ## number of speaker instances per pid in test set
    edf <- edf+sum(pidmap) ## number of instances in ntest PIDs
    
    dtest <- d[sdf:edf,]
    fdesc <- sprintf("Test set indices (fold %i): %i-%i", i, sdf, edf)
    
    if (i == 1){           ## train on last n-1 folds
      dtrain <-  d[(edf+1):ld,]
    }
    else if (i == nfold){  ## train on first n-1 folds
      dtrain <- d[1:(sdf-1),]
    }
    else {     ## make training set out of two discontinuous foldsets
      dtrain <- rbind(d[1:(sdf-1),],d[(edf+1):ld,])
    }
    sdf <- edf+1

    ref <- as.character(dtest$speaker[which(dtest[[target]]=='TRUE')])
    if (length(ref)<ntest){ ## if some speakers missing in some sessions
      ref <- c(ref, rep(categMode(ref),ntest-length(ref))) ## fill blanks with most common category 
    }
    didx <- c(features,which(names(d)==target)) ## restrict datasets to columns containing *only*
                                              # instance representation and target info
    hyp <- classifyByGroups(classifier,
                            dtrain[,didx], dtest[,didx], ## train/test dfs, approap. constrained
                            pidmap, ## group map (from session x PID table)
                            as.character(dtest[['speaker']]), ## target map
                            controlpars=controlpars)
    
    condCat('\nEvaluating',af, '\non classifier', quote(classifier),
            '- threshold:',results$threshold[i],'\n',
            print=debuglevel>=0)
    condCat('--------------------------------------\n',
            print=debuglevel>=0)
    condCat('Split: ', ntest*100/lt, '%  -- ', fdesc , '\n', sep='', print=debuglevel>=0)
    if (debuglevel>0){
      cat('Ref: ', as.character(ref), '\n',sep='')
      cat('Hyp: ', as.character(hyp), '\n',sep='')
    }
    condCat('\n', print=debuglevel>=0)
    tmpt <-
      paste("Overall accuracy: %.3f\n",
            sep='\n')
    ## overall accuracy 
    A <- accuracy(hyp,ref)

    condCat(sprintf(tmpt,
                    A), print=debuglevel>=0)
    
    results$hyp[i] <- list(hyp)
    #results$prob[i] <- list(prob)
    results$ref[i] <- list(ref)
  }
  results
}

## run train-test sessions on the same session
runExpertExperimentBySession <- function(af, ntest=4, ...) {
  if (is.data.frame(af)){
    d <- af
  }
  else
    d <- read.arff(af)
  sessions <- levels(d$session)
  results <- vector("list", length(sessions))
  names(results) <- sessions
  for (s in levels(d$session)){
    results[[s]] <- runExpertExperiment(d[d$session==s,], ntest=ntest, title=s, ...)
  }
  results
}

## example concatenateResults(results, names(DATADESC), 'hyp')
## returns all hypotheses from all sessions tested in runExpertExperimentBySession()
concatenateResults <- function(reslist, sessions=names(reslist), label='hyp'){
  res <- c()
  for (s in sessions){
    res <- c(res,  as.character(unlist(reslist[[s]][[label]])))
  }
  res
}

## average over all sessions of a results list
resultsAccuracyByPID <- function(reslist, sessions=names(reslist)){
  sapply(sessions, function(X) mean(unlist(reslist[[X]]$ref)==unlist(reslist[[X]]$hyp)))
}

## average over all sessions of a results list
resultsAccuracySDByPID <- function(reslist, sessions=names(reslist)){
  sapply(sessions, function(X) sd(unlist(reslist[[X]]$ref)==unlist(reslist[[X]]$hyp)))
}


## Take the most frequent expert prediction per session and compare it to ground truth
resultsAccuracyBySession <- function(reslist, sessions=names(reslist)){
  sapply(sessions, function(X) categMode(unlist(reslist[[X]]$ref))==categMode(unlist(reslist[[X]]$hyp)))
}

## e.g. runExpertExperimentSeries(generateExpertLeaderDataSet(), 14:1)
runExpertExperimentSeries <- function(af, ## generateExpertLeaderDataSet() output
                                      ntestseries=14:4, ...) {
  res <- list(trainsize=16-ntestseries, pidA=c(), pidAsd=c(), sessionA=c()) 
  for(n in ntestseries){
    r <- runExpertExperimentBySession(af, ntest=n, ...)
    pa <- resultsAccuracyByPID(r)
    sa <- resultsAccuracyBySession(r)
    res$pidA <-  c(res$pidA, mean(pa))
    res$pidAsd <-  c(res$pidAsd, sd(pa))
    res$sessionA <-  c(res$sessionA, mean(sa))
  }
  res
}



makeKnnClassifier <- function(){
  make_Weka_classifier("weka/classifiers/lazy/IBk")
}

makeNBClassifier <- function(){
  make_Weka_classifier("weka/classifiers/bayes/NaiveBayes")
}

## general classify function (instance-by-instance testing)
classify <- function(classifier, dtrain, dtest, type='class', controlpars=alist()){
  m <- trainClassifier(classifier, dtrain, controlpars=controlpars)
  testClassifier(m, dtest, type=type)
}

## classifiation by taking the maximum from within a group of
## instances. The goal is to predict which instance within a group of
## instances corresponds to the target instance. The target is assumed
## to be unique.
##
## Example: for a representation <InstID, (representation), target?>
## we could have
##
##  InstanceGroup = {<1, (repres_1...), FALSE>,
##                   <2, (repres_2...), TRUE>,
##                   <3, (repres_3...), FALSE>}
##
## classifyByGroups() will return the instance that is most likely to
## be the target, that is, \arg\max_{i=1}^3
## P(i,repres_i|target)P(target)
classifyByGroups <- function(classifier, ## a classifier
                             dtrain,     ## training set (excluding target info other than last column)    
                             dtest,      ## test set (excluding target info other than last column)
                             groupmap,   ## number of instances in each group of dtest
                             targetmap,  ## target IDs (same length as number of dtest rows)
                             controlpars=alist()){
  m <- trainClassifier(classifier, dtrain, controlpars=controlpars)
  ## get conditional probabilitiess (column 2 = TRUE)
  probs <- testClassifier(m,dtest,type='probability')[,2]
  i <- 1
  hyp <- c()
  ## argmax for each group
  for (g in groupmap){## g contains the number of instances in group
    hyp <- c(hyp, targetmap[which.max(probs[i:(i+g-1)])])
    i <- i+g
  }
  hyp
}

trainClassifier <- function(classifier, dtrain, controlpars=alist()){
  ## set classifier control parameters
  if ("R_Weka_classifier_interface" %in% class(classifier)) ## is this a weka classifier?
    if (length(controlpars)>0)
      control <- do.call('Weka_control', controlpars)
    else
      control <- NULL
  else
    control <- controlpars
  ## create formula (of the form 'target ~ .' for classification)
  formula <- paste(names(dtrain)[length(names(dtrain))], "~ .")
  if (length(controlpars)>0)
    modl <- do.call(classifier, list(formula, data=dtrain, control=control))
  else
    modl <- do.call(classifier, list(formula, data=dtrain))
  modl
}

testClassifier <- function(model, dtest, type='class'){
  ## make R model formula for classification
  predict(model,dtest,type=type)
}
  

## evaluation 
recall <- function(hyp, ref, class){
  target <- which(ref == class)
  tp <- sum(hyp[target]==class)
  tpUfn <- length(target)
  if (tpUfn==0)
    NA  ## if there is nothing in the target, recall makes no sense, so return NA
  else
    tp/tpUfn    
}

precision <- function(hyp, ref, class){
  target <- which(ref == class)
  if (length(target)==0) ## if there is nothing ref, precision makes no sense, so return NA
    return(NA)
  tp <- sum(hyp[target]==class)
  tpUfp <- length(which(hyp == class))
  if (tpUfp==0)
    0
  else
    tp/tpUfp
}

Fbeta <- function(hyp,ref,class,beta=1){
  target <- which(ref == class)
  if (length(target)==0) ## if there is nothing ref, precision makes no sense, so return NA
    return(NA)
  P <- precision(hyp,ref,class)
  R <- recall(hyp,ref,class)
  if (is.na(P) || is.na(R))
    return(NA)
  if (P+R==0)
    0
  else
    ((1 + beta^2)*P*R)/(beta^2*P+R)
}

Fscore <- function(P, R, beta=1){
  if (is.na(P) || is.na(R))
    return(NA)
  if (P+R==0)
    0
  else
    ((1 + beta^2)*P*R)/(beta^2*P+R)
}

accuracy <- function(hyp, ref, class=NULL){
  if (is.null(class))
    true <- ref==hyp
  else
    true <- ref[ref==class]==hyp[ref==class]
# if (length(true)==0)
#    0
#  else
    mean(true)
}

## probs = problem data set, as generated by  makeProblemTimeScoresDataSet()
## n = number of iterations to run
## class = the target class (T or F; F by default, since it is the 'harder' category)
mcSimulateCorrectnessClass <- function(probs, n=1000, class=F){
  gencor <-  mean(probs$correct) ## prior prob of correct=TRUE
  ## recall for class
  Rc <- mean(sapply(1:n, function(X)recall(sample(c(F,T), length(probs$correct),
                                                      replace=T, prob=c(1-gencor, gencor)),
                                               probs$correct, class)))
  ## precision for class
  Pc <- mean(sapply(1:n, function(X)precision(sample(c(F,T), length(probs$correct),
                                                      replace=T, prob=c(1-gencor, gencor)),
                                               probs$correct, class)))
  cat('MC simulation (', n, 'runs)\n--------------------\n - Precision: ',
      Pc,                                              '\n - Recall:    ', Rc, '\n', sep='')
  c(Pc, Rc)
}


## print results summary produced by runExpertExperiment() and runExperiment()
##
printResultsSummary <- function(results, beta){
  nfold <- length(results$hyp)
  af <- results$call

  hyp <- unlist(results$hyp)
  ref <- unlist(results$ref)
  ## macroavreages
  mAf <- mean(sapply(1:length(results$ref),
                    function(X){accuracy(results$hyp[[X]],results$ref[[X]],F)}))
  mRf <- mean(sapply(1:length(results$ref),
                    function(X){recall(results$hyp[[X]],results$ref[[X]],F)}), na.rm=T)
  mPf <- mean(sapply(1:length(results$ref),
                    function(X){precision(results$hyp[[X]],results$ref[[X]],F)}),  na.rm=T)
  mFf <- mean(sapply(1:length(results$ref),
                    function(X){Fbeta(results$hyp[[X]],results$ref[[X]],F,beta=beta)}),  na.rm=T)
  mAt <- mean(sapply(1:length(results$ref),
                    function(X){accuracy(results$hyp[[X]],results$ref[[X]],T)}),  na.rm=T)
  mRt <- mean(sapply(1:length(results$ref),
                    function(X){recall(results$hyp[[X]],results$ref[[X]],T)}),  na.rm=T)
  mPt <- mean(sapply(1:length(results$ref),
                    function(X){precision(results$hyp[[X]],results$ref[[X]],T)}),  na.rm=T)
  mFt <- mean(sapply(1:length(results$ref),
                    function(X){Fbeta(results$hyp[[X]],results$ref[[X]],T,beta=beta)}),  na.rm=T)

  cat('\nSummary for experiment "', results$title,
      '\nAvg over ', nfold, '-fold evaluation ', 
      'for "', af, '"\non classifier', results$clname, ' and threshold ',
      results$threshold[1],'.\n',sep='')
  cat('=====================================\n\n')

  tmpt <-
      paste("TRUE                     FALSE",
            "-------------------      ----------------------",
            "Accuracy:   %.3f         Accuracy:  %.3f",
            "Precision:  %.3f         Precision: %.3f ",
            "Recall:     %.3f         Recall:    %.3f ",
            "F_%i:        %.3f         F_%i:       %.3f\n",
            sep='\n')
  cat(sprintf(tmpt,
              ## microaverages
              accuracy(hyp,ref,TRUE),        accuracy(hyp,ref,FALSE),
              precision(hyp,ref,TRUE),       precision(hyp,ref,FALSE),
              recall(hyp,ref,TRUE),          recall(hyp,ref,FALSE),
              beta, Fbeta(hyp,ref,TRUE,beta=beta), beta, Fbeta(hyp,ref,FALSE,beta=beta)
              ),      
      sprintf(paste("Precision:  %.3f         Precision: %.3f       (macro-averaged)",
                    "Recall:     %.3f         Recall:    %.3f       (macro-averaged)",
                    "F_%i:        %.3f         F_%i:       %.3f       (macro-averaged)",
                    sep='\n'),
              mPt, mPf,
              mRt, mRf,
              beta, mFt, beta, mFf
              ),
      '\n', sep='')

}

plotROCCurve <- function(results, abline=TRUE, add=0, xpos=0.8, ypos=0.4, lineskip=.05,
                         auclabel='AUC = ', cols=1:8, ...){
  library('ROCR')
  PR <- prediction(unlist(results$prob), unlist(results$ref))
  plot(performance(PR, measure="tpr", x.measure="fpr"), col=cols[add+1], add=add>0, ...)
  auctxt <- paste(auclabel, round(performance(PR, measure="auc")@y.values[[1]],
                                  digits=3))
  text(xpos, ypos-(add*lineskip), auctxt, col=cols[add+1])
  #mtext( paste('AUC = ', performance(PR, measure="auc")@y.values[[1]]))
  if (abline && add == 0){
    abline(0,1,col=2, lty=2)
  }
  auctxt
}


### silly utilities
splitLabelFile <- function(datadir='../data/', sessions=names(DATADESC)) {
  df <- data.frame(vstart=NULL,vend=NULL,speaker=NULL,session=NULL)
  for (s in sessions) {
    d <- read.csv(file=paste(datadir,s,'.csv',sep=''), sep='\t',  header=F, col.names=c('vstart','vend','label'))
    di <-  c(which(d$label==1),length(d$label)+1)
    for (i in 1:(length(di)-1)){
      file <- paste('/tmp/',s,'-S',DATADESC[[s]]$speakers[i],'.txt',sep='')
      cat('writing', file, '\n')
      write.table(d[di[i]:(di[i+1]-1),], file=file, sep='\t',row.names=F,col.names=F,quote=F)
    }
  }
}

as.hhmmssTime <- function(time){
  sapply(as.character(time),
         function(t) {
           if (sum(unlist(strsplit(t,NULL))==':')==1){
             paste('0:',t,sep='') }
           else{
             t}},
         USE.NAMES=F)
}

condCat <- function(..., print=T){
  if (print)
    cat(...)
}

##
## get the modal category of a vector of nominals
categMode <- function(nominals){
  names(which.max(table(nominals)))[1]
}
